// Lawson Labs, Inc.
// 3217 Phoenixville Pike
// Malvern, PA  19355
// 800 321-5355 or 406 257-5355             
// 6-13-18
// filename: NT_m201

//6-13-18 replaced clrscr() macro with system("cls")
//	since it fails in Win10 - perhaps because Win10
//  won't accept the handle to the console used in macro



#include <windows.h>
#include <stdio.h>
#include <dos.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>
#include <ctype.h>
#include <string.h>
#include <time.h>
#include "NT_m201a.h"

//#define dbgMSG_BOX(_msg_) MessageBox(0, _msg_, "timMSG", MB_OK); 
#define dbgMSG_BOX(_msg_)


HANDLE	hOutCon, hInCon, hLibM201;
COORD	pos, dwCursorPosition;
CONSOLE_CURSOR_INFO	ConsoleCursorInfo;
CONSOLE_SCREEN_BUFFER_INFO lpConsoleScreenBufferInfo;
DWORD	lpNumberOfCharsWritten;

// following macro allows use of gotoxy and clrscr 
// functions used by previous 16-bit and Win32s code
#define gotoxy(x, y) pos.X = x; pos.Y = y - 1;	\
SetConsoleCursorPosition(hOutCon, pos);


/* //6-13-18 replaced with system("cls") wherever this macro was called
#define clrscr() pos.X = 0; pos.Y = 0;		\
FillConsoleOutputCharacter(hOutCon, ' ',	\
80*25, pos, &lpNumberOfCharsWritten);
*/
T_M201  M201;  
T_M201 *pM201;

int			cc[6];
int startCC, endCC; 
int n2;

double dblScan, dblScan1, dblScan2, dblSecRoll, dblRollScan, scanIntervalLocal, fTime;  //12-28-16


//12-28-16 new function - get scan details as used by DLL:
void GetScanDetails(void)
{
     if (pM201->timeBaseCnt < 0)
     {
       dblSecRoll = 3906.25 / pow(2, M201.baud);			//# of rollovers for 1 second @ 9600 baud
     }
     else  //or it is a Model 202
     {
       dblSecRoll = 4882.8125 / pow(2,M201.baud);			//# of rollovers for 1 second @ 9600 baud
     }

	 //{ char buff[256]; sprintf(buff, "GetScanDetails-> dblSecRoll: %lf, M201->baud: %d", dblSecRoll, M201.baud); MessageBox(0, buff, "message", MB_OK); }
     dblRollScan = dblSecRoll * (pM201->scanInterval + .00005) - 1;     //rollovers per scan
	 //{ char buff[32];sprintf(buff, "pM201->scanInterval: %lf, dblRollScan: %lf", pM201->scanInterval, dblRollScan); MessageBox(0, buff, "message", MB_OK); }
     dblScan2 = (dblRollScan / 65536l);						//calculate scan interval vars
	 //{ char buff[32]; sprintf(buff, "dblScan2: %lf", dblScan2); MessageBox(0, buff, "message", MB_OK); }
     dblRollScan -= ((long)dblScan2 * 65536l);
	 //{ char buff[32]; sprintf(buff, "dblRollScan: %lf", dblRollScan); MessageBox(0, buff, "message", MB_OK); }
     dblScan1 = (dblRollScan / 256);                        //put in M201 format
	 //{ char buff[32]; sprintf(buff, "dblScan1: %lf", dblScan1); MessageBox(0, buff, "message", MB_OK); }
     dblRollScan -= ((long)dblScan1 * 256);
	 //{ char buff[32]; sprintf(buff, "dblRollScan: %lf", dblRollScan); MessageBox(0, buff, "message", MB_OK); }
     dblScan = dblRollScan;
	 //{ char buff[32]; sprintf(buff, "dblRollScan: %lf", dblRollScan); MessageBox(0, buff, "message", MB_OK); }
}



int __cdecl main(void)
{

	//3-11-02 ########################
	int received = 0, scanWords;
	BOOLEAN fQuickExitScan = FALSE;
	//3-11-02 ########################


	pM201 = &M201;
	pNewScanBuff = NewScanBuff;

	FILE		*out;
 
	long rawCount, scanCnt;

	int 		i,n,p_row = 14,logging, ccode,Ch;


	double 		voltage, max=-12000, min=12000;
	char 		fileName[12], tmpbuf[80];;
	short		receiveError, localAvg=1, checkSum = 1;
	int			tempCh, tempSub;  // timtest

	short 		bauds[]={  //  table for baud rate codes
								/* 0 */  9600,
								/* 1 */  4800,
								/* 2 */  2400,
								/* 3 */  1200,
								/* 4 */   600,
								/* 5 */   300};
	//variables for standard deviation calculation
	double		stDv=0, rmsBits=0, sdTot = 0, runningAvg=0, sd[41];;
	int    		sdCount=1;
	M201.timeBaseCnt = -1;

	//if(long(1) > 1) MessageBox(0, "test", "", 0);

	//dbgMSG_BOX("test");

	hOutCon = GetStdHandle(STD_OUTPUT_HANDLE);
	if(!hOutCon)
	{
		MessageBox(0, "Error writing to console", "-- error", MB_OK);
		return 1;
	}
	hInCon =  GetStdHandle(STD_INPUT_HANDLE);
	if(!hInCon)
	{
		MessageBox(0, "Error reading from console", "-- error", MB_OK);
		return 1;
	}

	ConsoleCursorInfo.dwSize=1;
	ConsoleCursorInfo.bVisible = TRUE;

	if(!LoadLibraries())
		exit(1);

	if(!CheckLibFuncs())
	{
		UnloadLibraries();
		exit(1);
	}

	if (!ReadConfig(&localAvg))
	{
	  gotoxy(24,10);
	  printf("unable to read 201EWIN.CFG file");
	  gotoxy(26,11);
	  printf("press any key to continue");
	  getch();
	}



	GetScanDetails(); //12-28-16


	if(!SetPtrs(pM201, pNewScanBuff))
	{
		MessageBox(0, "Could not set required pointers\n"
					"  between application and DLL", "-- error", MB_OK);
		UnloadLibraries();
		exit(1);
	}


	M201.standBy = 0;			//set to not in standby
	M201.sleeping = 0;			//set to awake


TOP_MENU:

  Ch = 0;

  while(Ch != 27)
  {
	 system("cls");  //6-13-18
	 gotoxy(22,4);
	 printf ("MODEL 201 Data Acquisition System");
	 gotoxy(34,6);
	 printf ("Main Menu");
	 gotoxy(20,8);
	 printf ("1) Baud rate          %4d",bauds[M201.baud]);
	 gotoxy(20,10);
	 printf ("2) Serial port        COM%d",M201.comPort+1);
	 gotoxy(20,12);
	 printf ("3) Input buffer     %6d bytes",M201.RXQUEUESIZE);
	 gotoxy(20,14);
	 printf ("4) Polled Mode");
	 gotoxy(20,16);
	 printf ("5) Scanning Mode");
	 gotoxy(18,18);
	 printf ("Esc) Exit program");

	 if (M201.sleeping)
	 {
		gotoxy(20,20);
		printf("Model 201 is in sleep mode");
	 }

	 Ch = getch();
	

	 if (Ch == 27)
	 {
		goto EXIT_POINT;
	 }

	 if (Ch == '1')
	 {

		if (M201.baud++ == 5)
		{
		  M201.baud = 0;
		}

	 }

	 if (Ch == '2')
	 {

		if (M201.comPort++ == 3)
		{
		  M201.comPort = 0;
		}

	 }

	 if (Ch == '3')
	 {
		system("cls");  //6-13-18
		SetWin32CursorOn();
		gotoxy (14,12);
		printf("(enter between 11 and 32767)");
		gotoxy(15,10);
		printf("Enter size of input buffer  ");
		//12-28-16 getch();    
		fgets(tmpbuf,80,stdin);
		sscanf(tmpbuf,"%d",&M201.RXQUEUESIZE);
		SetWin32CursorOff();

		if (M201.RXQUEUESIZE < 11)
		{
			M201.RXQUEUESIZE = 11;
		}

	 }

	 if (Ch == '4')
	 {
		M201.sleeping = 0;
		system("cls");  //6-13-18
		gotoxy(30,12);
		printf("Signing on...");

		if (!SignOn())
		{
		  gotoxy(16,14);
		  printf ("unable to sign on.  Press any key to continue");
		  getch();
		  goto TOP_MENU;
		}

		GetComHandle(&IdComDev);		//get handle to comm port

		gotoxy(20,12);
		printf("Performing system calibration...");
		SysCal();

		GetVer();			//get version
		RemoteAvg();		//set averaging
		SetChanCode();		//set channel and subchannel

		FilterDelay(M201.filter);	//wait filter settling time

		system("cls");  //6-13-18
		goto POLLED;
	 }

	 if (Ch == '5')
	 {
		system("cls");  //6-13-18
		goto GET_SCANS;
	 }

  } //while Ch != 27

goto EXIT_POINT;

POLLED:

  system("cls");  //6-13-18
  gotoxy(1, 1);
  PrintCommandMenu(Ch, localAvg, checkSum);
  while (Ch != 27)			//repeat until esc key pressed or an error
  {

	 while (!kbhit() && !M201.standBy)//loop until keyboard hit
	 {
		gotoxy(1,p_row++);

		voltage = 0;
		rawCount = 0;

		for (i=0;i<localAvg;i++)
		{
		  if(!GetConversion())
		  {
			 gotoxy(1,23);
			 printf("get conversion failed, press any key to continue");
			 printf("\n       %X       ",M201.errorType);
			 while (Ch != 27)
			 {
				Ch = getch();
			 }

			 goto TOP_MENU;
		  }

		  voltage += M201.voltage;
		  rawCount += M201.rawCount;
		}
		M201.voltage = voltage/localAvg;
		M201.rawCount = rawCount/localAvg;

		printf ("   %9ld     %9.3lf",M201.rawCount,M201.voltage);

		if (max < M201.voltage)
		{
		  max = M201.voltage;               //update maximum
		}

		if (min > M201.voltage)
		{
		  min = M201.voltage;               //update minimum
		}

		StandardDev(&stDv, &rmsBits, &sdTot,
					&runningAvg, sd, &sdCount);

		if (p_row == 23)
		{
		  p_row = 14;
		  gotoxy(40,14);
		  printf ("Maximum     %9.3lf mv       ", max);
		  gotoxy (40,15);
		  printf ("Minimum     %9.3lf mv       ", min);
		  gotoxy (40,16);
		  printf ("Delta       %9.3lf mv       ", fabs(max - min));
		  gotoxy (40,17);
		  printf ("Average     %9.3lf mv       ", runningAvg);
		  gotoxy (40,19);
		  printf ("Standard deviation  %9.3lf mv    ", stDv);
		  gotoxy (40,20);
		  printf ("Effective Resolution  %5.1lf   bits", rmsBits);
		  gotoxy (1,14);
		}

	 }   //while (!kbhit()  && !M201.standBy)

	 Ch = getch();

	 if (Ch != 27)
	 {

		if (islower(Ch))
		{
		  Ch = toupper(Ch);
		}

		if (Ch == 'C' || Ch == 'E' || Ch == 'G' || Ch == 'P' || Ch == 'W')
		{
		  stDv=0; rmsBits=0; sdTot = 0; runningAvg=0; sdCount=1;
		}

		DoCommand(Ch, &max, &min, &localAvg, &checkSum);

	 }

	 if (M201.sleeping)
	 {
		goto TOP_MENU;
	 }

  }	//while (Ch != 27)

  goto TOP_MENU;			//end of polled mode example


GET_SCANS:					//start of scanned mode example

  tempCh = M201.channel;	//hold values for current channel and subchannel
  tempSub = M201.subChan;

  if (!ScanMenu())			//setup scanning details
  {
	 goto TOP_MENU;
  }

  M201.sleeping = 0;
  system("cls");  //6-13-18
  gotoxy(30,12);
  printf("Signing on...");
  if (!SignOn())			//signon again with new scanning details
  {
	 gotoxy(16,14);
	 printf ("unable to sign on.  Press any key to continue");
	 getch();
	 goto TOP_MENU;
  }

  GetComHandle(&IdComDev);	//get handle to comm port

  gotoxy(20,12);
  printf("Performing system calibration...");
  SysCal();

  RemoteAvg();

  system("cls");  //6-13-18

  logging = 0;

  SetWin32CursorOn();
  gotoxy(20,13);
  printf("Enter name for disk file,");
  gotoxy(20,15);
  printf("or just enter for no file ");
  getch();   
  gets(fileName);
  SetWin32CursorOff();

  if (strlen(fileName))
  {
	 logging = 1;
  }

  if(logging)
  {
	 if ((out = fopen(fileName, "at"))== NULL)
	 {
		gotoxy(20,19);
		printf("Could not open/create file\n");
		goto END_SCANS;
	 }
  }

  M201.numChannels = 0;

  for (n= 0;n<=5;n++)				//initialize control code array
  {
	 cc[n] = (M201.chan[n] & 0x0f) - (M201.chan[n]>>4) + 1;  // timtest
	 M201.numChannels += cc[n];		//figure total number of channels/scan
  }

  system("cls");  //6-13-18

  scanCnt = 0;

  if (M201.tScan == 0)
  {
	 ccode = M201.subChan + 3;		//setup location vars for display of
	 n = M201.channel * 12 + 5;		//single channel voltages
	 SetChanCode();					//set control code for single channel scanning
  }
  StartScanning();  				//Start scanning using selected scan type

  system("cls");  //6-13-18
  gotoxy(1, 1);
  printf(" CC    chan 0      chan 1      chan 2     ");
  printf(" chan 3      chan 4      chan 5\n\n");
  for(i=0;i<=15;i++)
  {
	 printf(" %d\n",i);
  }
  gotoxy(2,25);
  printf("Wait               Press any key to quit    ");
  printf("Scan interval %10.3lf secs",M201.scanInterval);


SCANSTATUS:

  while(!kbhit())					//while no keystroke
  {
	//################################
	//3-11-02 ########################
	fQuickExitScan = FALSE;
	while(TRUE)
	{
		received = (UINT)GetNumScansInBuffer();

		//== For debugging ==========
		//static UINT uiCnt = 0; uiCnt++; gotoxy(2,23); printf("%u", uiCnt);

		if((received >= 1) || (received == 0xffffffff)) break;
		if(kbhit()) { fQuickExitScan = TRUE; break; }
	}
	if(fQuickExitScan) break;
	//3-11-02 ########################
	//################################

	 receiveError = GetOneScan();	//get one scan from comm
	 if (receiveError != 0)
	 {
		gotoxy(2,25);
		printf("SCAN # %ld", ++scanCnt);
		
		if(M201.tScan == 0)
		{
		  gotoxy(n,ccode);
		  Gconv();				//get voltage
		  printf("%9.3lf", M201.voltage);
		  if (logging)
		  {
			 fprintf(out,"%9.3lf  ", M201.voltage);
		  }

		  if (logging)
		  {
			 fprintf(out,"\n");
		  }

		  goto SCANSTATUS;
		}
		
		if(M201.tScan == 2)
		{
		  gotoxy(2,23);
		  printf("Offset cal ");
		  Gconv();				//get voltage
		  printf("   %9.3lf", M201.voltage);

		  if (logging)
		  {
			 fprintf(out,"%9.3lf  ", M201.voltage);
		  }

		  gotoxy(27,23);
		  printf("Full scale cal ");
		  Gconv();				//get voltage
		  printf("   %9.3lf", M201.voltage);

		  if (logging)
		  {
			 fprintf(out,"%9.3lf  ", M201.voltage);
		  }
		}
		

		for(n2 = 0; n2 <= 5; n2++)					//display channel voltages
		{
		  startCC = (int)(M201.chan[n2] / 16);
		  endCC = cc[n2] + startCC - 1;

		  for(ccode=startCC;ccode<=endCC;ccode++)
		  {
			 gotoxy((n2 * 12) + 5,(ccode + 3));
			 Gconv();				//get voltage
			 printf("%9.3lf", M201.voltage);

			 if (logging)
			 {
			  	fprintf(out,"%9.3lf  ", M201.voltage);
			 }

		  }

		}

		if (logging)
		{
		   fprintf(out,"\n");
		}

		if(NewScanBuff[0] != 0x0F)			// should be end of scan token
		{
		   printf("End scan framing failure ");
		   getch();
		   goto END_SCANS;
		}

		RemFromBuffer(1);		//remove end scan token
	 }
	 else
	 {
		gotoxy(2,19);
		if (M201.errorType == 1)
		{
		  printf("Start scan framing failure\n");
		}

		if (M201.errorType == 2)
		{
		  printf("not enough chars, possible communications error");
		}

		if (M201.errorType == 3)
		{
		  printf("buffer overflow");
		}

		if (M201.errorType == 0xA)
		{
		  printf("scan rate too fast for this scan type");
		}

		printf("\n press any key to continue");
		getch();

		goto END_SCANS;
	 }

  }									//end while !kbhit()
END_SCANS:
  if (logging)
  {
	 fclose(out);
  }

  gotoxy(1,25);
  printf("                    Wait                 ");

  while(kbhit())					//empty keyboard buffer
  {
	 getch();
  }


 StopScanning();					//Tell the Model 201 to stop scanning

 M201.channel = tempCh;		  		//restore channel and subchannel
 M201.subChan = tempSub;

 goto GET_SCANS;					//end of scanning example

EXIT_POINT:

	CloseDevice();					//close comm port
	UnloadLibraries();
	system("cls");  //6-13-18
	printf("\nDo you wish to save configuration (y/n)?  ");
	Ch = getch();
	printf("\n");

	if (Ch == 'Y' || Ch == 'y')
	{

	  WriteConfig(&localAvg);
	}

	return 0;

}

//   Get starting & ending control codes for a scanning channel
short GetChannel(int value)
{
short channel;

startCC=-1;
endCC=-1; 

static char  tmpbuf1[80];

	while ((startCC < 0) || (startCC > 15))
	{
	  system("cls");  //6-13-18
	  gotoxy(4,23);
	  printf( "Enter an end code smaller than the start code to skip this channel");

	  SetWin32CursorOn();
	  gotoxy(1,12);
	  printf("Channel number:    %d\n",value);
	  printf("Enter starting control code  ");
	  //12-28-16 getch();    

	  tmpbuf1[1] = 0;
	  fgets(tmpbuf1,80,stdin);

	  if (tmpbuf1[1] >= '0')
	  {
		 startCC =  (short)((tmpbuf1[0] - '0')*10);
		 startCC += (short)(tmpbuf1[1] - '0');
	  }
	  else
	  {
		 startCC = (short)(tmpbuf1[0] - '0');
	  }

	}

	while ((endCC < 0) || (endCC > 15))
	{
	  printf("Enter ending control code  ");

	  //12-28-16 getch();    
	  tmpbuf1[1] = 0;
	  fgets(tmpbuf1,80,stdin);
	  SetWin32CursorOff();

	  if (tmpbuf1[1] >= '0')
	  {
		 endCC =  (short)((tmpbuf1[0] - '0')*10);
		 endCC += (short)(tmpbuf1[1] - '0');
	  }
	  else
	  {
		 endCC = (short)(tmpbuf1[0] - '0');
	  }

	}

	if ( startCC > endCC)
	{
		startCC = 1;
		endCC = 0;
	}

	channel = (short)(startCC * 16 + endCC);
	return channel;
}


void PrintCommandMenu(int Ch, short localAvg, short checkSum)
{
int nn;

  gotoxy (10,1);
  printf ("POLLED  MENU   Lawson Labs Model 201   Version=%d\n", M201.version);
  gotoxy (5,3);
  printf ("C) A/D input Channel    %d", M201.channel);
  gotoxy (5,4);
  printf ("E) External sub-channel %d", M201.subChan);

  if (M201.subChan < 10)
  {
	 printf (" ");
  }

  gotoxy (5,5);
  printf ("A) remote Averaging     %d", M201.average);
  gotoxy (5,6);
  printf ("L) Local averaging      %d        ", localAvg);
  gotoxy (5,7);

  printf ("T) filTer             ");
  if (M201.filter == 0)
  {
	 printf ("  4 hz");
  }
  else if (M201.filter == 1)
  {
	 printf (" 40 hz ");
  }
  else
  {
	 printf ("400 hz ");
  }

  gotoxy (5,8);
  printf ("G) Gain factor        %3d",M201.gain);

  gotoxy (5,9);
  printf ("R) sample Rate       %6.1lf",M201.rate);

  gotoxy (5,10);
  printf( "B) ");
  if (M201.standBy)
  {
	 printf("in standBy mode    ");
  }
  else
  {
	 printf("out of standBy mode");
  }

  gotoxy (43,3); printf ("D) Digital inputs ");

  if (Ch == 'D')
  {
	 printf ("  %d",M201.lastDigInp);

	 if (M201.lastDigInp < 100)
	 {
		printf ("  ");
	 }

	 gotoxy (61,2); printf ("Decimal 76543210\n");
	 gotoxy (69,3);

	 for (nn = 7;nn != -1; nn--)
	 {

		if (M201.lastDigInp&(int)(pow(2, nn)))
		{
		  printf ("1");
		}
		else
		{
		  printf ("0");
		}

	 }

  }

  gotoxy (43,4); printf ("U) digital oUtput   ");

  if (Ch == 'U')
  {
	 printf ("%d  ",M201.digOutWord);
	 Ch = 0;
  }

  gotoxy (43,5); printf ("K) checKsum         ");

  if (Ch == 'K')
  {
	 if (checkSum)
	 {
		printf ("     OK");
	 }
	 else
	 {
		printf (" not OK");
	 }

  }
  else
  {
	 printf ("        ");
  }

  gotoxy (43,6);
  printf ("S) System calibration");
  gotoxy (43,7);
  printf ("O) Offset calibration");

  gotoxy (43,8);
  printf ("W) Word length      ");

  if (M201.wordCnt == 3)
  {
	 printf("24 bits");
  }
  else
  {
	 printf("16 bits");
  }

  gotoxy (43,9);
  printf ("P) Polarity        ");

  if (M201.biPolar)
  {
	 printf (" Bipolar");
  }
  else
  {
	 printf ("Unipolar");
  }

  gotoxy (43,10);
  printf ("Z) sleep");

  gotoxy (6,12); printf ("Counts      Millivolts\n");
  gotoxy (1,24);
  printf (" Press ESC for menu or space to reset max/min                       ");
}


void    StandardDev(double *stDv, double *rmsBits, double *sdTot,
					double *runningAvg, double *sd, int *sdCount)
{//standard deviation and RMS resolution calculation
	int i = 0, nnn,sdGrp=40, bits;
	double tempStDv;

	sd[*sdCount] = M201.rawCount;
	(*sdTot) += M201.rawCount;

	if ((*sdCount) == sdGrp)
	{
		(*stDv) = 0;
		(*sdTot) = (*sdTot) / sdGrp;

		for (nnn = 1; nnn != sdGrp; nnn++)
		{
			(*stDv) = (*stDv) + ((*sdTot) - sd[nnn])*((*sdTot) - sd[nnn]);
		}

		(*stDv) = sqrt((*stDv) / (sdGrp-1));
		tempStDv = (*stDv);

CALCNEXT:

		if (tempStDv >= 1)
		{
			i = i + 1;
			tempStDv = tempStDv / 2;
			goto CALCNEXT;
		}

		if (M201.wordCnt == 3)
		{
			bits = 24;
		}
		else
		{
			bits = 16;
		}

		(*rmsBits) = bits - i;

		if ((tempStDv < .75) && (i != 0))
		{
			(*rmsBits) = (*rmsBits) + .5;
		}

		M201.rawCount = (long)*sdTot;
		*runningAvg = Counts2Volts();

		M201.rawCount = (long)*stDv;
		*stDv = Counts2Volts();

		if (M201.biPolar)
		{
			(*stDv) += 5000;		//unipolar voltage range
		}

		(*sdTot) = 0; (*sdCount) = 1;
	}
	else
	{
		(*sdCount)++;
	}
}

void DoCommand(int Ch, double *max,	double *min,
					short *localAvg, short *checkSum)
{
char tempCh=0;
short tempSubChan, tempGain;
char tmpbuf[80];

  if (islower(Ch))
  {
	 Ch = toupper(Ch);
  }

  gotoxy (1,24);
  printf ("                                                   ");

  if (Ch == 'Z')
  {
	 M201.sleeping = GotoSleep();
  }

  if (Ch == 'T')
  {

	 if(++M201.filter == 3)
	 {
		M201.filter = 0;
	 }

	 SetFilter(M201.filter);
  }

  if (Ch == 'R')
  {
	 SelectRate();
  }

  if (Ch == 'B')
  {

	 if(M201.standBy)
	 {
		M201.standBy = 0;
	 }
	 else
	 {
		M201.standBy = 1;
	 }

	 SendADMode();
  }

  if (Ch == 'G')
  {
	 M201.gain = (short)fmod(M201.gain*2,255);
	 SendADMode();
  }

  if (Ch == 'P')
  {

	 if(M201.biPolar)
	 {
		M201.biPolar = 0;
	 }
	 else
	 {
		M201.biPolar = 1;
	 }

	 SendADMode();

	 SysCal();

	 SetChanCode();

  }

  if (Ch == 'W')
  {
	 if(M201.wordCnt == 2)
	 {
		M201.wordCnt = 3;
	 }
	 else
	 {
		M201.wordCnt = 2;
	 }

	 SendADMode();
  }

  if (Ch == 'A')
  {

	 while((tempCh != 27) && (tempCh != 13))
	 {

		while (!kbhit())
		{
		  gotoxy (1,24);
		  printf ( "Press + increase, - decrease averaging, Enter to continue ");
		  printf ( "%6d", M201.average);
		}

		tempCh =(BYTE) getch();
		if (tempCh == '+')
		{
		  M201.average *= 2;
		}

		if (tempCh == '-')
		{
		  M201.average /= 2;
		}

		if (M201.average  < 1)
		{
		  M201.average = 32678;
		}
		else if (M201.average > 32678)
		{
		  M201.average = 1;
		}

	 }

	 RemoteAvg();
  }

  if (Ch == 'C')
  {
	 tempCh = -1;

	 while ((tempCh < '0') || (tempCh > '7'))
	 {
		gotoxy(1,24);
		printf("Enter channel ");
		tempCh =(BYTE)getche();
	 }

	 M201.channel = (short)(tempCh - '0');

	 SetChanCode();
	 gotoxy(1,24);
    printf("                       waiting filter settling time...");
	 FilterDelay(M201.filter);

  }

  if (Ch == 'D')
  {
	 GetDigIn();
  }

  if (Ch == 'E')
  {
	 tempSubChan = -1;

	 while ((tempSubChan < 0) || (tempSubChan > 15))
	 {
	   SetWin32CursorOn();
		gotoxy(1,24);
		printf("Enter sub channel ");
		//12-28-16 getch();    
		tmpbuf[1] = 0;
		fgets(tmpbuf,80,stdin);
		SetWin32CursorOff();

		if (tmpbuf[1] >= '0')
		{
		  tempSubChan =  (short)((tmpbuf[0] - '0')*10);
		  tempSubChan += (short)(tmpbuf[1] - '0');
		}
		else
		{
		  tempSubChan = (short)(tmpbuf[0] - '0');
		}

	 }

	 M201.subChan = tempSubChan;

	 SetChanCode();

	 system("cls");  //6-13-18  
	 gotoxy(1,24);
     printf("                       waiting filter settling time...");
	 FilterDelay(M201.filter);

  }

  if (Ch == 'L')
  {
	 (*localAvg) = 0;
	 SetWin32CursorOn();

	 while ((*localAvg) < 1)
	 {
		gotoxy(1,24);
		printf("Enter local averaging ");
		//12-28-16 getch();    
		fgets(tmpbuf,80,stdin);
		sscanf(tmpbuf,"%d",localAvg);
	 }

	 SetWin32CursorOff();

  }

  if (Ch == 'K')
  {
	 (*checkSum) = GetCheckSum();
  }

  if (Ch == 'S')
  {
	 gotoxy(31,24);
	 printf("Calibrating...");
	 tempCh = (BYTE)M201.channel;
	 tempGain = M201.gain;
	 if (M201.gain != 1)
	 {
		M201.gain = 1;
		SendADMode();
	 }

	 SysCal();

	 if (tempGain != 1)
	 {
		M201.gain = tempGain;
		SendADMode();

		M201.channel = 7;
		OffsetCal();
	 }

	 M201.channel=tempCh;
	 SetChanCode();

	 FilterDelay(M201.filter);

  }

  if (Ch == 'O')
  {
	 gotoxy(31,24);
	 printf("Calibrating...");
	 OffsetCal();
  }

  if (Ch == 'F')
  {
	 gotoxy(31,24);
	 printf("Calibrating...");
	 FullScaleCal();
  }

  if (Ch == 'U')
  {
	 M201.digOutWord = -1;
	 SetWin32CursorOn();

	 while ((M201.digOutWord < 0) || (M201.digOutWord > 255))
	 {
		gotoxy(1,24);
		printf ("Enter Output Code ");
		//12-28-16 getch();    
		fgets(tmpbuf,80,stdin);
		sscanf(tmpbuf,"%d",&M201.digOutWord);
	 }

	 SetWin32CursorOff();
	 SetDigOut(M201.digOutWord);
  }

  if (Ch == ' ')
  {
	 (*max) = -12000.0;
	 (*min) = 12000.0;				//reset max-min
  }

  if(!M201.sleeping)
  {
	 PrintCommandMenu(Ch, (*localAvg), (*checkSum));
  }

}


short ScanMenu()					//displays the scanning menu (returns 1 if
									//set to start scanning
{
int Ch, n, vala;
short	i;

char tmpbuf[80];

SCANMENU1:  
  system("cls");  //6-13-18
  M201.numChannels = 0;

  for (n= 0;n<=5;n++)				//initialize control code array
  {
	 cc[n] = (M201.chan[n] & 0x0f) - (M201.chan[n]>>4) + 1;  
	 M201.numChannels += cc[n];		//figure total number of channels/scan
  }

  gotoxy(27,1);
  printf("SCANNING  CONFIGURATION");
  gotoxy(14,3);
  printf("CHANNEL      EXTERNAL CONTROL CODE      NUMBER OF");
  gotoxy(54,4);
  printf("DATA POINTS");

  if(M201.tScan == 0)
  {
	 M201.subChan = (short)(M201.singleChan&15);
	 M201.channel = (short)(M201.singleChan>>4);
	 gotoxy(18,7);
	 printf ("%d",M201.channel);
	 printf("               %d                 1", M201.subChan);
	 gotoxy(15,10);
	 printf("   PRESS 0 - 5 FOR CHANNEL");
  }
  else
  {
	 gotoxy(29,5);
	 printf("FROM           TO        THIS CHANNEL");

	 for (n=0;n<=5;n++)
	 {
		gotoxy(17,7 + n * 2);
		printf("%d)           ", n);
		printf( "%2d            %2d           %2d",M201.chan[n]>>4, (int)fmod((double)M201.chan[n],16), cc[n]);
	 }
  }

  gotoxy(17,19);
  printf("6) Scan Interval  %11.4lf seconds",M201.scanInterval);

  if((M201.gain != 1) && (M201.tScan == 2))
  {
	 M201.tScan = 0;				//no cal scan unless gain=1
  }

  gotoxy(17,21);
  printf("7) Scan type: ");

  if (M201.tScan == 0)
  {
	 printf ("Single Channel  ");
  }
  else if (M201.tScan == 1)
  {
	 printf ("Normal          ");
  }
  else
  {
	 printf ("Self-Calibration");
  }

  gotoxy(11,23);
  printf("  Enter) Perform the scan");
  gotoxy(15,24);
  printf("Esc) To continue");

  if(M201.tScan > 0)
  {
	 printf("         data points per scan  %d",M201.numChannels);
  }

  Ch = getch();
  vala = Ch -'0';

  if((vala == 0) && (Ch != '0'))
  {
	 vala = 10;						//flag invalid keystroke
  }

  if((vala >= 0) && (vala <= 5))
  {

	 if (M201.tScan == 0)
	 {
		system("cls");  //6-13-18
		gotoxy(10,12);
		printf("Channel number:    %d",vala);

		SetWin32CursorOn();
		gotoxy(10,14);
		printf ("Enter external control code, 0 - 15 ");
		//12-28-16 getch();    
		fgets(tmpbuf,80,stdin);
		sscanf(tmpbuf,"%d",&M201.subChan);
		SetWin32CursorOff();

		M201.subChan = (short)fmod((double)M201.subChan,16.0);
		M201.channel =(short)vala;
		M201.singleChan =(short)((vala<<4) +  M201.subChan);
	 }
	 else
	 {
		M201.chan[vala] = GetChannel(vala);
	 }

  }

  if(vala == 6)
  {
	 i = CheckScanTime(&maxTime, &minTime);
	 CalcScanTime();
  }

  if(vala == 7)
  {

	 if (M201.tScan == 0)
	 {
		M201.tScan = 1;
	 }
	 else if (M201.tScan == 1)
	 {
		M201.tScan = 2;
	 }
	 else
	 {
		M201.tScan = 0;
	 }

	 if (M201.gain != 1 && M201.tScan == 2)
	 {
		M201.tScan = 0;
	 }

  }

  if(Ch == 13)
  {

	 if(M201.numChannels == 0)
	 {
		printf("You must enter control codes first, press any key to continue");
		getch();
		goto SCANMENU1;

	 }

	 i = CheckScanTime(&maxTime, &minTime);

	 if (i==2)
	 {
		 printf("Reduced averaging to %d- Press any key to continue",M201.average);
		 getch();
	 }
	 else if(!i)
	 {
		system("cls");  //6-13-18
		gotoxy(10,15);
		printf("Scan time out of limits, press any key to continue");
		getch();
		CalcScanTime();
	 }

	 return 1;
  }

  if(Ch == 27)
  {
	 return 0;
  }

  goto SCANMENU1;

}


/****************************************************************************
Because all aspects of the scanning function of the Model 201 is programmable,
it can be difficult to determine what the optimal settings are for any
particular task. Also, if the A/D is not performing as intended, it can be
hard to determine the cause. An overview of how to set up the 201 from a
programmer's perspective follows.

The A/D is constantly performing conversions at DATARATE. This rate is set in
the mode registers of the A/D chip itself. Slower DATARATEs provide lower
noise, higher DATARATEs allow higher frequencies to be seen, and allow more
data points to be taken in the same time period.

For higher frequency applications the DATARATE should be set for the
appropriate low-pass filter cutoff frequency. The cutoff frequency is
approximately one quarter the DATARATE.

For DC and very low frequency applications, you would normally select the
lowest possible DATARATE. That lowest rate is determined by all the
programmable scanning variables - scan type, the number of channels scanned,
averaging, filter setting, word length and BAUD rate. Even though the
DATARATE is actually sent to the A/D before the rest of the scanning details
during the sign-on process, it should be calculated last. Details for Model
201 follow:


  M201.baud           = 0 for 9600, 1 for 4800, etc.
  M201.numChannels    = number of channels to scan
  M201.average        = number of conversions to average
								(1, 2, 4, 8, 16, 32 etc)
  M201.wordCnt        = number of bytes in conversion ( 2 or 3)
  M201.filter;		  = 0 = 4 Hz, 1 = 40 Hz, 2 = 400 Hz filter

  For the Model 201, fTime is based on the M201.filter setting:
	 0 (4 Hz), fTime = 4.5 seconds
	 1 (40 Hz), fTime = .56 seconds
	 2 (400 Hz), fTime = .036 seconds

Here, we have solved for the minimum sample rate given the scan interval:

  minSampleRate = (M201.average + 2) / ((M201.scanInterval - (M201.wordCnt *
				 .002333) * 2 ^ M201.baud) / M201.numChannels - (fTime * .82));

A 5 percent margin should provide comfort. The following line would take
care of that:

  M201.rate = 1.05 * minSampleRate;
****************************************************************************/
short CalcScanTime()	//select the scan interval
{

char tmpbuf[80];

short i;

  system("cls");  //6-13-18

CALCSCANTIME1:

  if(M201.numChannels == 0)
  {
	 printf("You must enter control codes first, press any key to continue");
	 getch();
	 return 0;
  }

  if (i==2)
  {
	 printf("Reduced averaging to %d- Press any key to continue",M201.average);
	 getch();
  }

  SetWin32CursorOn();
  gotoxy(10,10);
  printf("Enter scan time ");
  printf("%10.4lf  - ", minTime);
  printf( "%12.4lf  seconds  ", maxTime);
  //12-28-16 getch();   
  fgets(tmpbuf,80,stdin);
  sscanf(tmpbuf,"%lf",&M201.scanInterval);

  SetWin32CursorOff();

  i = CheckScanTime(&maxTime, &minTime);

  if (i==2)
  {
	 printf("Reduced averaging to %d- Press any key to continue",M201.average);
	 getch();
  }
  else if(!i)
  {
	 system("cls");  //6-13-18
	 gotoxy(10,15);
	 printf("Scan time out of limits, press any key to continue");
	 getch();
	 goto CALCSCANTIME1;
  }

  return 1;
}

void SelectRate()						//select the sampling rate for the A/D
{
char tmpbuf[80];

  SetWin32CursorOn();
  gotoxy(1,24);
  printf("            Enter sample rate between 10 and 1027  ");
  //12-28-16 getch();    
  fgets(tmpbuf,80,stdin);
  sscanf(tmpbuf,"%f",&M201.rate);
  SetWin32CursorOff();

  if (M201.rate > 1027)
  {
	 M201.rate = 1027;
  }
  else if (M201.rate < 10)
  {
	 M201.rate = 10;
  }

  SendADMode();

  SysCal();

  SetChanCode();

  system("cls");  //6-13-18
}

short ReadConfig(short *localAvg)
{
	char tmpbuf[80];
	FILE *rCfg;

	if ((rCfg = fopen("201ewin.cfg", "rt")) != NULL)
	{
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%u",&M201.TXQUEUESIZE);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%u",&M201.RXQUEUESIZE);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%u",&M201.baud);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%u",&M201.comPort);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%lf",&M201.scanInterval);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%u",&M201.numChannels);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%u",&M201.average);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%u",&M201.tScan);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%u",&M201.chan[0]);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%u",&M201.chan[1]);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%u",&M201.chan[2]);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%u",&M201.chan[3]);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%u",&M201.chan[4]);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%u",&M201.chan[5]);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%u",&M201.singleChan);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%u",&M201.channel);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%u",&M201.subChan);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%u",&M201.wordCnt);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%u",&M201.biPolar);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%u",&M201.filter);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%u",&M201.gain);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%f",&M201.rate);
	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%u",&M201.modeRegLo);
	  fgets(tmpbuf,20,rCfg);
	  sscanf(tmpbuf,"%u",&M201.modeRegMid);

	  UINT val = 0;
	  fgets(tmpbuf,80,rCfg);
	  //sscanf(tmpbuf,"%u",&M201.modeRegHi);
	  sscanf(tmpbuf,"%u",&val);
	  M201.modeRegHi = (short)val;

	  fgets(tmpbuf,80,rCfg);
	  sscanf(tmpbuf,"%u",localAvg);

	  { 
		//char buff[256];
		//sprintf(buff, "ReadConfig4->M201.baud: %u", M201.baud); 
		//MessageBox(0, buff, "message", MB_OK); 
	  }

	  fclose(rCfg);
	  return 1;
	}
	else
	{
	  M201.TXQUEUESIZE = 1;
	  M201.RXQUEUESIZE = 1024;
	  M201.baud = 0;
	  M201.comPort = 0;
	  M201.filter = 2;
	  M201.gain = 1;
	  M201.rate = 10;
	  M201.wordCnt = 3;
	  M201.biPolar = 1;
	  M201.average = 1;
	  M201.scanInterval = 2;
	  M201.numChannels = 6;
	  M201.chan[0]= 0;
	  M201.chan[1]= 0;
	  M201.chan[2]= 0;
	  M201.chan[3]= 0;
	  M201.chan[4]= 0;
	  M201.chan[5]= 0;
	  M201.singleChan = 0;
	  M201.tScan = 1;
	  M201.channel = 0;
	  M201.subChan = 0;
	  (*localAvg) = 1;
	  return 0;
	}

}


short WriteConfig(short *localAvg)
{
FILE *wCfg;

  if ((wCfg = fopen("201ewin.cfg", "wt")) != NULL)
  {
	 fprintf(wCfg,"%d\n",M201.TXQUEUESIZE);
	 fprintf(wCfg,"%d\n",M201.RXQUEUESIZE);
	 fprintf(wCfg,"%d\n",M201.baud);
	 fprintf(wCfg,"%d\n",M201.comPort);
	 fprintf(wCfg,"%lf\n",M201.scanInterval);
	 fprintf(wCfg,"%d\n",M201.numChannels);
	 fprintf(wCfg,"%d\n",M201.average);
	 fprintf(wCfg,"%d\n",M201.tScan);
	 fprintf(wCfg,"%d\n",M201.chan[0]);
	 fprintf(wCfg,"%d\n",M201.chan[1]);
	 fprintf(wCfg,"%d\n",M201.chan[2]);
	 fprintf(wCfg,"%d\n",M201.chan[3]);
	 fprintf(wCfg,"%d\n",M201.chan[4]);
	 fprintf(wCfg,"%d\n",M201.chan[5]);
	 fprintf(wCfg,"%d\n",M201.singleChan);
	 fprintf(wCfg,"%d\n",M201.channel);
	 fprintf(wCfg,"%d\n",M201.subChan);
	 fprintf(wCfg,"%d\n",M201.wordCnt);
	 fprintf(wCfg,"%d\n",M201.biPolar);
	 fprintf(wCfg,"%d\n",M201.filter);
	 fprintf(wCfg,"%d\n",M201.gain);
	 fprintf(wCfg,"%f\n",M201.rate);
	 fprintf(wCfg,"%d\n",M201.modeRegLo);
	 fprintf(wCfg,"%d\n",M201.modeRegMid);
	 fprintf(wCfg,"%d\n",M201.modeRegHi);
	 fprintf(wCfg,"%d\n",(*localAvg));
	 fclose(wCfg);
	 //return 1;
  }


  if ((wCfg = fopen("drivr201.cfg", "wt")) != NULL)
  {
	 fprintf(wCfg,"%d,",M201.modeRegHi);
	 fprintf(wCfg,"%d,",M201.modeRegMid);
	 fprintf(wCfg,"%d,",M201.modeRegLo);
	 fprintf(wCfg,"%d,",M201.channel);
	 fprintf(wCfg,"%d,",M201.filter);
	 fprintf(wCfg,"%d\n",(*localAvg));
	 fprintf(wCfg,"%d,",M201.subChan);
	 fprintf(wCfg,"%d,",M201.baud);
	 //fprintf(wCfg,"%s,","\"hey\"");

	 {
		char buff[32];
		sprintf(buff, "\"COM%d:\",",M201.comPort+1);
		fprintf(wCfg,"%s",buff);
	 }
	 fprintf(wCfg,"%d,",M201.RXQUEUESIZE);
	 fprintf(wCfg,"%d,",M201.average);
	 fprintf(wCfg,"%d,",M201.biPolar ^ 1);
	 fprintf(wCfg,"%d,",M201.gain);
	 fprintf(wCfg,"%lf,",M201.rate);
	 if(M201.wordCnt == 3)
		fprintf(wCfg,"%d\n",128);
	 else
		fprintf(wCfg,"%d\n",0);
	 fprintf(wCfg,"%d,",M201.chan[0]);
	 fprintf(wCfg,"%d,",M201.chan[1]);
	 fprintf(wCfg,"%d,",M201.chan[2]);
	 fprintf(wCfg,"%d,",M201.chan[3]);
	 fprintf(wCfg,"%d,",M201.chan[4]);
	 fprintf(wCfg,"%d\n",M201.chan[5]);
	 fprintf(wCfg,"%d\n",M201.singleChan);
	 fprintf(wCfg,"%d,",(UINT)dblScan);
	 fprintf(wCfg,"%d,",(UINT)dblScan1);
	 fprintf(wCfg,"%d,",(UINT)dblScan2);
	 fprintf(wCfg,"%lf,",M201.scanInterval);
	 fprintf(wCfg,"%d,",M201.tScan);
	 fprintf(wCfg,"%d\n",1);


/*
	 fprintf(wCfg,"%d\n",M201.TXQUEUESIZE);
	 fprintf(wCfg,"%d\n",M201.RXQUEUESIZE);
	 fprintf(wCfg,"%d\n",M201.baud);
	 fprintf(wCfg,"%d\n",M201.comPort);
	 fprintf(wCfg,"%lf\n",M201.scanInterval);
	 fprintf(wCfg,"%d\n",M201.numChannels);
	 fprintf(wCfg,"%d\n",M201.average);
	 fprintf(wCfg,"%d\n",M201.tScan);
	 fprintf(wCfg,"%d\n",M201.chan[0]);
	 fprintf(wCfg,"%d\n",M201.chan[1]);
	 fprintf(wCfg,"%d\n",M201.chan[2]);
	 fprintf(wCfg,"%d\n",M201.chan[3]);
	 fprintf(wCfg,"%d\n",M201.chan[4]);
	 fprintf(wCfg,"%d\n",M201.chan[5]);
	 fprintf(wCfg,"%d\n",M201.singleChan);
	 fprintf(wCfg,"%d\n",M201.channel);
	 fprintf(wCfg,"%d\n",M201.subChan);
	 fprintf(wCfg,"%d\n",M201.wordCnt);
	 fprintf(wCfg,"%d\n",M201.biPolar);
	 fprintf(wCfg,"%d\n",M201.filter);
	 fprintf(wCfg,"%d\n",M201.gain);
	 fprintf(wCfg,"%f\n",M201.rate);
	 fprintf(wCfg,"%d\n",M201.modeRegLo);
	 fprintf(wCfg,"%d\n",M201.modeRegMid);
	 fprintf(wCfg,"%d\n",M201.modeRegHi);
	 fprintf(wCfg,"%d\n",(*localAvg));
*/
	 fclose(wCfg);
	 return 1;
  }




  return 0;

}

void SetWin32CursorOn(void)
{
	ConsoleCursorInfo.bVisible = TRUE;
	SetConsoleCursorInfo(hOutCon, &ConsoleCursorInfo);
}

void SetWin32CursorOff(void)
{
	ConsoleCursorInfo.bVisible = FALSE;
	SetConsoleCursorInfo(hOutCon, &ConsoleCursorInfo);
}

BOOLEAN
LoadLibraries()
{
    hLibM201 = LoadLibrary ("NT_m201.dll");
    if(!hLibM201)
	{
		MessageBox(0, "Error loading NT_m201.DLL", "-- error", MB_OK);
		return FALSE;
	}
	return TRUE;
}

BOOLEAN
UnloadLibraries()
{
	FreeLibrary(hLibM201);
    hLibM201 = NULL;
	return TRUE;
}
 
//==== CHECKLIBFUNCS FUNCTION =================================================
BOOLEAN
CheckLibFuncs()
{
	BOOLEAN Status = TRUE;

	//#######################################
	//3-11-02 ## START ######################
    GetNumScansInBuffer = (DLL_GET_SCAN_PNT_CNT)GetProcAddress(hLibM201, "GetNumScansInBuffer");
    if(!GetNumScansInBuffer)
    {
        MessageBox(0, "failed to find function:\n     GetNumScansInBuffer()"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    GetNumBytesInBuffer = (DLL_GET_SCAN_BYTE_CNT)GetProcAddress(hLibM201, "GetNumBytesInBuffer");
    if(!GetNumBytesInBuffer)
    {
        MessageBox(0, "failed to find function:\n     GetNumBytesInBuffer()"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
	//3-11-02 ## END ########################
	//#######################################


    SetPtrs = (DLL_SET_PTRS)GetProcAddress(hLibM201, "SetPtrs");
    if(!SetPtrs)
    {
        MessageBox(0, "failed to find function:\n     SetPtrs(...)"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    SignOn = (DLL_SIGN_ON)GetProcAddress(hLibM201, "SignOn");
    if(!SignOn)
    {
        MessageBox(0, "failed to find function:\n     SignOn()"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    RemoteAvg = (DLL_REMOTE_AVG)GetProcAddress(hLibM201, "RemoteAvg");
    if(!RemoteAvg)
    {
        MessageBox(0, "failed to find function:\n     RemoteAvg(...)"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    Counts2Volts = (DLL_COUNTS_2_VOLTS)GetProcAddress(hLibM201, "Counts2Volts");
    if(!Counts2Volts)
    {
        MessageBox(0, "failed to find function:\n     Counts2Volts(...)"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    GetDigIn = (DLL_GET_DIG_IN)GetProcAddress(hLibM201, "GetDigIn");
    if(!GetDigIn)
    {
        MessageBox(0, "failed to find function:\n     GetDigIn(...)"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    GetVer = (DLL_GET_VER)GetProcAddress(hLibM201, "GetVer");
    if(!GetVer)
    {
        MessageBox(0, "failed to find function:\n     GetVer(...)"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    SetDigOut = (DLL_SET_DIG_OUT)GetProcAddress(hLibM201, "SetDigOut");
    if(!SetDigOut)
    {
        MessageBox(0, "failed to find function:\n     SetDigOut(...)"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    FullScaleCal = (DLL_FULL_SCALE_CAL)GetProcAddress(hLibM201, "FullScaleCal");
    if(!FullScaleCal)
    {
        MessageBox(0, "failed to find function:\n     FullScaleCal(...)"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    OffsetCal = (DLL_OFFSET_CAL)GetProcAddress(hLibM201, "OffsetCal");
    if(!OffsetCal)
    {
        MessageBox(0, "failed to find function:\n     OffsetCal(...)"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    SysCal = (DLL_SYS_CAL)GetProcAddress(hLibM201, "SysCal");
    if(!SysCal)
    {
        MessageBox(0, "failed to find function:\n     SysCal(...)"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    GetConversion = (DLL_GET_CONVERSION)GetProcAddress(hLibM201, "GetConversion");
    if(!GetConversion)
    {
        MessageBox(0, "failed to find function:\n     GetConversion(...)"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    SetChanCode = (DLL_SET_CHAN_CODE)GetProcAddress(hLibM201, "SetChanCode");
    if(!SetChanCode)
    {
        MessageBox(0, "failed to find function:\n     SetChanCode(...)"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    StartScanning = (DLL_START_SCANNING)GetProcAddress(hLibM201, "StartScanning");
    if(!StartScanning)
    {
        MessageBox(0, "failed to find function:\n     StartScanning(...)"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    GetOneScan = (DLL_GET_ONE_SCAN)GetProcAddress(hLibM201, "GetOneScan");
    if(!GetOneScan)
    {
        MessageBox(0, "failed to find function:\n     GetOneScan(...)"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    StopScanning = (DLL_STOP_SCANNING)GetProcAddress(hLibM201, "StopScanning");
    if(!StopScanning)
    {
        MessageBox(0, "failed to find function:\n     StopScanning(...)"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    Gconv = (DLL_GCONV)GetProcAddress(hLibM201, "Gconv");
    if(!Gconv)
    {
        MessageBox(0, "failed to find function:\n     Gconv(...)"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    RemFromBuffer = (DLL_REMOVE_FROM_BUFFER)GetProcAddress(hLibM201, "RemFromBuffer");
    if(!RemFromBuffer)
    {
        MessageBox(0, "failed to find function:\n     RemFromBuffer(...)"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    SetFilter = (DLL_SET_FILTER)GetProcAddress(hLibM201, "SetFilter");
    if(!SetFilter)
    {
        MessageBox(0, "failed to find function:\n     SetFilter(...)"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    SendADMode = (DLL_SEND_AD_MODE)GetProcAddress(hLibM201, "SendADMode");
    if(!SendADMode)
    {
        MessageBox(0, "failed to find function:\n     SendADMode(...)"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    GetCheckSum = (DLL_GET_CHECK_SUM)GetProcAddress(hLibM201, "GetCheckSum");
    if(!GetCheckSum)
    {
        MessageBox(0, "failed to find function:\n     GetCheckSum(...)"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    CloseDevice = (DLL_CLOSE_DEVICE)GetProcAddress(hLibM201, "CloseDevice");
    if(!CloseDevice)
    {
        MessageBox(0, "failed to find function:\n     CloseDevice(...)"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    GotoSleep = (DLL_GOTO_SLEEP)GetProcAddress(hLibM201, "GotoSleep");
    if(!GotoSleep)
    {
        MessageBox(0, "failed to find function:\n     GotoSleep(...)"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    FilterDelay = (DLL_FILTER_DELAY)GetProcAddress(hLibM201, "FilterDelay");
    if(!FilterDelay)
    {
        MessageBox(0, "failed to find function:\n     FilterDelay(...)"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    CheckScanTime = (DLL_CHECK_SCAN_TIME)GetProcAddress(hLibM201, "CheckScanTime");
    if(!CheckScanTime)
    {
        MessageBox(0, "failed to find function:\n     CheckScanTime(...)"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
    GetComHandle = (DLL_GET_COM_HANDLE)GetProcAddress(hLibM201, "GetComHandle");
    if(!GetComHandle)
    {
        MessageBox(0, "failed to find function:\n     GetComHandle(...)"
                "\nin nt_m201.dll\n\nEXITING", "IMPORTANT NOTICE ---", MB_OK);
		FreeLibrary(hLibM201);
        return FALSE;
    }
	return Status;
}


